#include <stdio.h>
#include <stdlib.h>
#include "config.h"
#include "memcpy.h"

extern short colortable[1380 * 4];
extern int bpp, x11_byteswap2, x11_bigendian2;
#ifdef ARCH_X86
static volatile unsigned long nMaskY[2] = { 0x00ff00ff, 0x00ff00ff };
static volatile unsigned long nMaskUV[2] = { 0xff00ff00, 0xff00ff00 };
static volatile unsigned long nPlus128[2] = { 0x80008000, 0x80008000 };
static volatile unsigned char nFaktoren[8] =
{ 0xbf + 5, 0xf9 + 5, 0x89 + 5, 0x19 + 5, 0x49 + 5, 0x20 + 5,
  0x03 /*0xfe+5 */ , 0xf2 + 5
};
static volatile unsigned long ands[2] = { 0x00f800f8, 0x00f800f8 };
#endif
static volatile char pCromaPuffer[2*768];
//static volatile unsigned long colortable_offset = 1376; // 4*32 + 4*312


#ifndef ARCH_X86
#define sat(x,max) if(x<0) x=0; if(x>max) x=max;
static inline short yuv_to_rgb16(unsigned char y, unsigned char cb, unsigned char cr) {
  /*Calculus:
    Y=255.0/219.0*(y-16)
    U=127.0/112.0*(cb-128)
    V=127.0/112.0*(cr-128);
    R<<16=(Y+1.402*V)/255*31*65536;
    G<<16=(Y-0.344*U-0.714*V)/255*63*65536;
    B<<16=(Y+1.772*V)/255*31*65536;
  */
  int y2,r,g,b;
  y2=9277*y;
  r=(-1769860+y2+12666*cr)>>16; sat(r,31);  
  g=(2184701+18853*y-6316*cb-13109*cr)>>16; sat(g,63);
  b=(-2197118+y2+16009*cb)>>16; sat(b,31);
  if(!x11_byteswap2)
    return b|(g<<5)|(r<<11);
  else
    return (g>>3)|(r<<3)|(b<<8)|((g&7)<<13);
}
static void yuvtorgb16(void *p2, void *p1, int xsize) {
  int i;
  unsigned char *pp1=p1;
  unsigned short *pp2=p2;
  for(i=0;i<xsize;i+=4,pp1+=4,pp2+=2) {
    pp2[0]=yuv_to_rgb16(pp1[0],pp1[1],pp1[3]);
    pp2[1]=yuv_to_rgb16(pp1[2],pp1[1],pp1[3]);
  }
}
static inline void yuv_to_rgb32(unsigned char y, unsigned char cb, unsigned char cr, unsigned char *r, unsigned char *g, unsigned char *b) {
  int y2,r2,g2,b2;
  y2=76309*y;
  r2=(-14556884+y2+104187*cr)>>16; sat(r2,255); *r=r2;
  g2=(8842838+y2-25564*cb-53060*cr)>>16; sat(g2,255); *g=g2;
  b2=(-18076354+y2+131683*cb)>>16; sat(b2,255); *b=b2;
}
static void yuvtorgb32(void *p2, void *p1, int xsize) {
  int i;
  unsigned char *pp1=p1, *pp2=p2;
  if(!x11_bigendian2)
    for(i=0;i<xsize;i+=4,pp1+=4,pp2+=8) {
      yuv_to_rgb32(pp1[0],pp1[1],pp1[3],&pp2[2],&pp2[1],&pp2[0]);
      yuv_to_rgb32(pp1[2],pp1[1],pp1[3],&pp2[6],&pp2[5],&pp2[4]);
    }
  else
    for(i=0;i<xsize;i+=4,pp1+=4,pp2+=8) {
      yuv_to_rgb32(pp1[0],pp1[1],pp1[3],&pp2[1],&pp2[2],&pp2[3]);
      yuv_to_rgb32(pp1[2],pp1[1],pp1[3],&pp2[5],&pp2[6],&pp2[7]);
    }
}
#define s8(x) if(x<-128) x=-128; if(x>127) x=127;
#define s16(x) if(x<-32768) x=-32768; if(x>32767) x=32767;
static void palyuv0(int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2, void *p1) {
  short *pColorFaktor;
  unsigned char *pp1=p1, *pp2=p2;
  int i;
  i1=i1&1; i2=i2&1;
  if(perm_y<32) perm_y=perm_y-offset32;
  pColorFaktor=&colortable[4*(1248+4*(perm_y-y)+i2+2*i1)];
  for(i=0;i<xsize;i+=4,pp1+=4,pp2+=4) {
    int u,v,U,V;
    U=pp1[1]-128; V=pp1[3]-128;
    u=(U*pColorFaktor[0]+V*pColorFaktor[1])>>13; s8(u);
    v=(U*pColorFaktor[2]+V*pColorFaktor[3])>>13; s8(v);
    pp2[1]=u+128; pp2[3]=v+128;
    pp2[0]=pp1[0]; pp2[2]=pp1[2];
  }
}
static void palyuv(int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2, void *p1) {
  short *pColorFaktor;
  unsigned char *pp1=p1, *pp2=p2;
  short *pc=(short*) pCromaPuffer;
  int i;
  i1=i1&1; i2=i2&1;
  if(perm_y<32) perm_y=perm_y-offset32;
  pColorFaktor=&colortable[4*(1248+4*(perm_y-y)+i2+2*i1)];
  for(i=0;i<xsize;i+=4,pp1+=4,pp2+=4,pc+=2) {
    int u,v,U,V,uprev,vprev;
    uprev=pc[0]; vprev=pc[1];
    U=pp1[1]-128; V=pp1[3]-128;
    u=(U*pColorFaktor[0]+V*pColorFaktor[1])>>14;
    s16(u); pc[0]=u;
    v=(U*pColorFaktor[2]+V*pColorFaktor[3])>>14;
    s16(v); pc[1]=v;
    u+=uprev; s8(u); v+=vprev; s8(v);
    pp2[1]=u+128; pp2[3]=v+128;
    pp2[0]=pp1[0]; pp2[2]=pp1[2];
  }
}
#endif

void plug_rgb16to15(unsigned short *img, int size) {
  int i;
  static unsigned short *conv;
  if(conv==NULL) {
    conv=(unsigned short *) malloc(65536*sizeof(unsigned short));
    for(i=0;i<65536;i++) {
      conv[i]=(i&0x001F)|((i>>1)&0x7FE0);
    }
  }
  for(i=0;i<size;i++) {
    img[i]=conv[img[i]];
  }
}

    //********************************************************************
    //                        P U T L I N E    P A L    Y V U
    //********************************************************************
inline void
putline_PAL_YVU (int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2, void *p1)
{
#ifdef ARCH_X86
  __asm__ __volatile__ (
                        // if (MSB(perm_y) == 1) i.e. if (perm_y > 32767 or 16383??) goto 1
                        "movl      %4,               %%eax\n\t"     // perm_y
                        "testl     %%eax,            %%eax\n\t"
                        "js        1f\n\t"

                        // if (perm_y >= 32) goto 0
                        "cmpl      $0x00000020, %%eax\n\t"
                        "jae       0f \n\t"

                        // else perm_y = perm_y - offset32;
                        "subl      %2,               %%eax\n\t"     // offset32
                        
     "0:\n\t"

                        // edi = 4 * (perm_y - y) + 1248
                        "subl      %3, %%eax\n\t"    // y
                        "leal      0x4E0(, %%eax,4), %%edi\n\t"

                        // i1 = i1 & 0x01
                        // i2 = i2 & 0x01
                        "movl      %0, %%eax\n\t"                   // i1
                        "movl      %1, %%ebx\n\t"                   // i2
                        "andl      $00000001, %%eax\n\t"
                        "andl      $00000001, %%ebx\n\t"

                        // edi = edi + (i2 + 2 * i1)
                        "leal      (%%ebx, %%eax,2), %%eax\n\t"
                        "addl      %%eax, %%edi\n\t"

                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal      colortable(, %%edi,8), %%edi\n\t"

     "1:\n\t"

                        "movl      %7, %%edx\n\t"                   // p1
                        "movl      %5, %%ecx\n\t"                   // xsize

                        "movq      (%%edi),  %%mm7\n\t"             // mm7 = *pColorFaktor (64 bits)
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
                        "movl       $%8, %%edi\n\t"                 // pCromaPuffer
#else
                        "movl       %8, %%edi\n\t"                  // pCromaPuffer
#endif
                        "movq       %9,   %%mm4\n\t"
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
                        "movq       %10,  %%mm5\n\t"
                        "movq       %11, %%mm6\n\t"
#else
                        "movq       nMaskUV,  %%mm5\n\t"
                        "movq       nPlus128, %%mm6\n\t"
#endif

                        "shrl       $3, %%ecx\n\t"                  // xsize (nBreiteQuelle) /= 8
                        "movl       %6, %%ebx\n\t"                  // p2 (pZiel)

                        "movq       (%%edx), %%mm0\n\t"             // mm0 = *p1 (pSource)

                        ".align 16\n\t"

     "2:\n\t" //NextPixel
                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1
                        "addl      $8, %%edx\n\t"                   // p1 += 8
                        "movq      %%mm0, %%mm2\n\t"                // mm2 = V2 Y3 U2 Y2 V0 Y1 U0 Y0  Y nach mm2
                        "psubb     %%mm6, %%mm0\n\t"                // mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0  U-128 V-128
                        "pand      %%mm4, %%mm2\n\t"                // mm2 = 00 Y3 00 Y2 00 Y1 00 Y0  Y Ausmaskieren
                        "psraw     $8, %%mm0\n\t"                   // mm0 = V2 V2 U2 U2 V0 V0 U0 U0  U und V auf 16 Bit erweitern
                        "movq      %%mm0, %%mm1\n\t"                // mm1 = V2 V2 U2 U2 V0 V0 U0 U0  Zweites Pixelpaar nach mm1
                        "punpckldq %%mm0, %%mm0\n\t"                // mm0 = V0 V0 U0 U0 V0 V0 U0 U0  Untere 32 Bit in die oberen 32 Bit kopieren
                        "punpckhdq %%mm1, %%mm1\n\t"                // mm1 = V2 V2 U2 U2 V2 V2 U2 U2  Obere 32 Bit in die unteren 32 Bit kopieren
                        "pmaddwd   %%mm7, %%mm0\n\t"                // mm0 = v0 v0 v0 v0 u0 u0 u0 u0  u0 = U0 * *(pColorFaktor+0) + V0 * *(pColorFaktor+1);
                                                                    //   v0 = U0 * *(pColorFaktor+2) + V0 * *(pColorFaktor+3);
                        "pmaddwd   %%mm7, %%mm1\n\t"                // mm1 = v2 v2 v2 v2 u2 u2 u2 u2  u2 = U2 * *(pColorFaktor+0) + V2 * *(pColorFaktor+1);
                                                                    //   v2 = U2 * *(pColorFaktor+2) + V2 * *(pColorFaktor+3);
                        "psrad     $14, %%mm0\n\t"                  // mm0 = v0 v0 v0 v0 u0 u0 u0 u0  Geteilt durch 16384
                        "psrad     $14, %%mm1\n\t"                  // mm1 = v2 v2 v2 v2 u2 u2 u2 u2  Geteilt durch 16384
                        "packssdw  %%mm1, %%mm0\n\t"                // mm0 = v2 v2 u2 u2 v0 v0 u0 u0  Ergebnis auf 16 bit krzen
                        "movq      -8(%%edi, %%ecx, 8), %%mm3\n\t"  // mm3 = v2 v2 u2 u2 v0 v0 u0 u0  Farbwerte der letzten Zeile
                        "movq      %%mm0, -8(%%edi, %%ecx, 8)\n\t"  // mm0 = v2 v2 u2 u2 v0 v0 u0 u0  Farbe fr nchste Zeile merken
                        "paddsw    %%mm3, %%mm0\n\t"                // mm0 = v2 v2 u2 u2 v0 v0 u0 u0  Farbwerte der letzten Zeile addieren
                        "packsswb  %%mm0, %%mm0\n\t"                // mm0 = v2 u2 v0 u0 v2 u2 v0 u0  Auf 8 Bit krzen
                        "punpcklbw %%mm0, %%mm0\n\t"                // mm0 = v2 v2 u2 u2 v0 v0 u0 u0
                        "pand      %%mm5, %%mm0\n\t"                // mm0 = v2 00 u2 00 v0 00 u0 00  U und V ausmaskieren
                        "psubb     %%mm6, %%mm0\n\t"                // mm0 = v2 00 u2 00 v0 00 u0 00  U+128 V+128
                        "por       %%mm0, %%mm2\n\t"                // mm2 = v2 Y3 u2 Y2 v0 Y1 u0 Y0

                        "movq      %%mm2, (%%ebx)\n\t"              // *pZiel = mm2
                        "addl      $8, %%ebx\n\t"                   // pZiel += 8

                        "decl      %%ecx\n\t"                       // nBreiteQuelle--
                        "jne       2b\n\t" //NextPixel              // Sind noch weitere Pixel in dieser Zeile

                        "emms\n\t"                                  // MMX zurcksetzen

                        :    /* no output */
                        :    /* input */
                        "m" (i1),          /* %0 */
                        "m" (i2),          /* %1 */
                        "m" (offset32),    /* %2 */
                        "m" (y),           /* %3 */
                        "m" (perm_y),      /* %4 */
                        "m" (xsize),       /* %5 */
                        "m" (p2),          /* %6 */
                        "m" (p1),          /* %7 */
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
                        "m" (*pCromaPuffer), /* %8 */
#else
                        "m" (pCromaPuffer), /* %8 */
#endif
			"m" (*nMaskY)      /* %9 */
/* gcc >= 3.2 (?) supports more than 10 operands */
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
			,
			"m" (*nMaskUV),   /* %10*/
			"m" (*nPlus128)   /* %11*/
#endif
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );                        
#else
  palyuv(i1, i2, offset32, y, perm_y, xsize, p2, p1);
#endif
}

    //********************************************************************
    //                        P U T L I N E    P A L   R G B 1 6
    //********************************************************************
inline void
putline_PAL_RGB16 (int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2,
         void *p1)
{
#ifdef ARCH_X86
  __asm__ __volatile__ (
                        // if (MSB(perm_y) == 1) i.e. if (perm_y > 32767 or 16383??) goto 1
                        "movl      %4, %%eax\n\t"                   // perm_y
                        "testl     %%eax, %%eax\n\t"
                        "js        1f\n\t"

                        // if (perm_y >= 32) goto putlinePALRGB16m1
                        "cmpl      $0x00000020, %%eax\n\t"
                        "jae       0f\n\t"

                        // else perm_y = perm_y - offset32;
                        "subl      %2, %%eax\n\t"                   // offset32
                        
        "0:\n\t"

                        // edi = 4 * (perm_y - y) + 1248
                        "subl      %3, %%eax\n\t"    // y
                        "leal      0x4E0(, %%eax,4), %%edi\n\t"

                        // i1 = i1 & 0x01
                        // i2 = i2 & 0x01
                        "movl      %0, %%eax\n\t"                   // i1
                        "movl      %1, %%ebx\n\t"                   // i2
                        "andl      $00000001, %%eax\n\t"
                        "andl      $00000001, %%ebx\n\t"

                        // edi = edi + (i2 + 2 * i1)
                        "leal      (%%ebx, %%eax,2), %%eax\n\t"
                        "addl      %%eax, %%edi\n\t"

                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal      colortable(, %%edi,8), %%edi\n\t"

        "1:\n\t"

                        "movl      %7, %%edx\n\t"                   // p1
                        "movl      %5, %%ecx\n\t"                   // xsize

                        "movq      (%%edi), %%mm7\n\t"              // mm7 = *pColorFaktor (64 bits)
                        "movq      %8, %%mm4\n\t"

                        "shrl      $3, %%ecx\n\t"                   // xsize /= 8
                        "movl      %6, %%ebx\n\t"                   // p2

                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1

                        "addl      $8, %%edx\n\t"                   // p1 += 8

                        "subl      $8, %%ebx\n\t"                   // p2 -= 8 

                        "jmp       3f\n\t" //StartPixel

                        ".align 16\n\t"

        "2:\n\t" // NextPixel
                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1
                        "addl      $8, %%edx\n\t"                   // p1 += 8
                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 = mm2


        "3:\n\t" // StartPixel
                        "movq      %%mm0, %%mm2\n\t"
                        "psubb     %9, %%mm0\n\t"             // U-128 V-128
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "psraw     $8, %%mm0\n\t"
                        "pand      %%mm4, %%mm2\n\t"                // unmask UV
                        "movq      %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw     $1, %%mm2\n\t"
                        "pmaddwd   %%mm7, %%mm0\n\t"                // mm0 += *pColorFaktor
                        // ??? movq mm6
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq      %%mm2, %%mm5\n\t"
                        "pmaddwd   %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad     $0x0B, %%mm0\n\t"
                        "psrad     $0x0B, %%mm1\n\t"
                        "packssdw  %%mm1, %%mm0\n\t"
                        // ??? movd eax
                        "packssdw  %%mm1, %%mm1\n\t"
                        "paddsw    %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t"
                        "movq      %%mm0, %%mm6\n\t"
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
                        "movq      %10, %%mm3\n\t"
#else
                        "movq      nFaktoren, %%mm3\n\t"
#endif
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw    %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw    %%mm3, %%mm0\n\t"
                        "movq      %%mm2, %%mm1\n\t"
                        "psllq     $8, %%mm2\n\t"
                        "movq      %%mm6, %%mm3\n\t"
                        "psrlq     $0x30, %%mm6\n\t"
                        "por       %%mm1, %%mm2\n\t"
                        "paddsw    %%mm3, %%mm6\n\t"
                        "movq      %%mm5, %%mm3\n\t"
                        "psllq     $8, %%mm5\n\t"
                        "packsswb  %%mm6, %%mm6\n\t"
                        "movq      %%mm0, %%mm1\n\t"
                        "psrlq     $0x30, %%mm0\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "paddsw    %%mm1, %%mm0\n\t"
                        "pxor      %%mm1, %%mm1\n\t"
                        "packsswb  %%mm0, %%mm0\n\t"
                        "pxor      %%mm3, %%mm3\n\t"
                        "paddsb    %%mm0, %%mm5\n\t"
                        "paddsb    %%mm6, %%mm2\n\t"
                        "pcmpgtb   %%mm5, %%mm3\n\t"
                        "pandn     %%mm5, %%mm3\n\t"
                        "pcmpgtb   %%mm2, %%mm1\n\t"
                        "movq      %%mm3, %%mm0\n\t"
                        "pand      %%mm4, %%mm3\n\t"
                        "psrld     $0x0A, %%mm0\n\t"
                        "pandn     %%mm2, %%mm1\n\t"
                        "pslld     $0x1B, %%mm0\n\t"                // 0x1A
                        "movq      %%mm3, %%mm5\n\t"
                        "psrlw     $2, %%mm3\n\t"
                        "movq      %%mm1, %%mm2\n\t"
                        "psrld     $1, %%mm5\n\t"                   // 02
                        "pand      %%mm4, %%mm1\n\t"
                        "pslld     $0x15, %%mm5\n\t"
                        "por       %%mm0, %%mm5\n\t"
                        "movq      %%mm1, %%mm0\n\t"
                        "psrlw     $2, %%mm1\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "psrld     $1, %%mm0\n\t"                   // 02
                        "pslld     $0x15, %%mm0\n\t"
                        "psrad     $0x10, %%mm5\n\t"
                        "por       %%mm0, %%mm1\n\t"
                        "psrld     $0x0A, %%mm2\n\t"
                        "pslld     $0x1B, %%mm2\n\t"                // 0x1A
                        "por       %%mm1, %%mm2\n\t"
                        "psrad     $0x10, %%mm2\n\t"
                        "decl      %%ecx\n\t"
                        "packssdw  %%mm5, %%mm2\n\t"
                        "jne       2b\n\t" // NextPixel

                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 = mm2

        "4:\n\t" //end
                        "emms\n\t"
                        :        /* no output */
                        :        /* input */
                        "m" (i1),       /* %0 */
                        "m" (i2),       /* %1 */
                        "m" (offset32), /* %2 */
                        "m" (y),        /* %3 */
                        "m" (perm_y),   /* %4 */
                        "m" (xsize),    /* %5 */
                        "m" (p2),       /* %6 */
                        "m" (p1),       /* %7 */
			"m" (*nMaskY),   /* %8 */
			"m" (*nPlus128) /* %9 */
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
			,"m" (*nFaktoren) /* %10 */
#endif
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );
#else
  // not equivalent to the assembler routine....
  static char buf[768*2];
  palyuv0(i1, i2, offset32, y, perm_y, xsize, buf, p1);
  yuvtorgb16(p2, buf, xsize);
#endif
}

inline void
putline_PAL_RGB15 (int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2,
         void *p1)
{
  putline_PAL_RGB16(i1, i2, offset32, y, perm_y, xsize, p2, p1);
  plug_rgb16to15(p2, xsize/2);
}

    //********************************************************************
    //                        P U T L I N E   P A L   R G B 3 2
    //********************************************************************

inline void
putline_PAL_RGB32 (int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2,
         void *p1)
{
#ifdef ARCH_X86
  __asm__ __volatile__ (
                        // if (MSB(perm_y) == 1) i.e. if (perm_y > 32767 or 16383??) goto 1
                        "movl      %4, %%eax\n\t"                   // perm_y
                        "testl     %%eax, %%eax\n\t"
                        "js        1f\n\t"

                        // if (perm_y >= 32) goto 0
                        "cmpl      $0x00000020, %%eax\n\t"
                        "jae       0f\n\t"

                        // else perm_y = perm_y - offset32;
                        "subl      %2, %%eax\n\t"                   // offset32

        "0:\n\t"

                        // else perm_y = perm_y - offset32;
                        "subl      %3, %%eax\n\t"                   // y
                        "leal      0x4E0(, %%eax,4), %%edi\n\t"

                        // i1 = i1 & 0x01
                        // i2 = i2 & 0x01
                        "movl      %0, %%eax\n\t"                   // i1
                        "movl      %1, %%ebx\n\t"                   // i2
                        "andl      $00000001, %%eax\n\t"
                        "andl      $00000001, %%ebx\n\t"

                        // edi = edi + (i2 + 2 * i1)
                        "leal      (%%ebx, %%eax,2), %%eax\n\t"
                        "addl      %%eax, %%edi\n\t"

                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal      colortable(, %%edi,8), %%edi\n\t"

        "1:\n\t"

                        "movl      %7, %%edx\n\t"                   // p1
                        "movl      %5, %%ecx\n\t"                   // xsize

                        "movq      (%%edi), %%mm7\n\t"              // mm7 = *pColorFaktor (64 bits)
                        "movq      %8, %%mm4\n\t"

                        "shrl      $3, %%ecx\n\t"                   // xsize /= 8
                        "movl      %6, %%ebx\n\t"                   // p2

                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1

                        "addl      $8, %%edx\n\t"                   // p1 += 8

                        "subl      $8, %%ebx\n\t"                   // p2 -= 8

                        "jmp       3f\n\t" //StartPixel

                        ".align 16\n\t"

	"2:\n\t" //NextPixel
                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1
                        "addl      $8, %%edx\n\t"                   // p1 += 8
                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 = mm2
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "movq      %%mm5, (%%ebx)\n\t"              // *p2 = mm5

        "3:\n\t" //StartPixel
                        "movq      %%mm0, %%mm2\n\t"
                        "psubb     %9, %%mm0\n\t"                   // U-128 V-128
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "psraw     $8, %%mm0\n\t"
                        "pand      %%mm4, %%mm2\n\t"                // unmask UV
                        "movq      %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw     $1, %%mm2\n\t"
                        "pmaddwd   %%mm7, %%mm0\n\t"                // mm0 += *pColorFaktor
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq      %%mm2, %%mm5\n\t"
                        "pmaddwd   %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad     $0x0B, %%mm0\n\t"
                        "psrad     $0x0B, %%mm1\n\t"
                        "packssdw  %%mm1, %%mm0\n\t"
                        "packssdw  %%mm1, %%mm1\n\t"
                        "paddsw    %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t"
                        "movq      %%mm0, %%mm6\n\t"
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
                        "movq      %10, %%mm3\n\t"
#else
                        "movq      nFaktoren, %%mm3\n\t"
#endif
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw    %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw    %%mm3, %%mm0\n\t"
                        "movq      %%mm2, %%mm1\n\t"
                        "psllq     $8, %%mm2\n\t"
                        "por       %%mm1, %%mm2\n\t"
                        "movq      %%mm6, %%mm3\n\t"
                        "psrlq     $0x30, %%mm6\n\t"
                        "paddsw    %%mm3, %%mm6\n\t"
                        "packsswb  %%mm6, %%mm6\n\t"
                        "movq      %%mm5, %%mm3\n\t"
                        "psllq     $8, %%mm5\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "movq      %%mm0, %%mm1\n\t"
                        "psrlq     $0x30, %%mm0\n\t"
                        "paddsw    %%mm1, %%mm0\n\t"
                        "packsswb  %%mm0, %%mm0\n\t"
                        "paddsb    %%mm0, %%mm5\n\t"
                        "paddsb    %%mm6, %%mm2\n\t"
                        "pxor      %%mm1, %%mm1\n\t"
                        "pxor      %%mm3, %%mm3\n\t"
                        "pcmpgtb   %%mm5, %%mm3\n\t"
                        "pandn     %%mm5, %%mm3\n\t"
                        "pcmpgtb   %%mm2, %%mm1\n\t"
                        "pandn     %%mm2, %%mm1\n\t"
                        "movq      %%mm3, %%mm0\n\t"
                        "psrld     $0x0A, %%mm0\n\t"                // t
                        "pslld     $0x13, %%mm0\n\t"                // R
                        "pand      %%mm4, %%mm3\n\t"
                        "movq      %%mm3, %%mm5\n\t"
                        "psrld     $1, %%mm5\n\t"                   // t
                        "psllw     $0x0A, %%mm5\n\t"                // G
                        "por       %%mm0, %%mm5\n\t"
                        "psrlw     $0x02, %%mm3\n\t"
                        "psrld     $0x0d, %%mm3\n\t"                // t
                        "por       %%mm3, %%mm5\n\t"                // B
                        "movq      %%mm1, %%mm2\n\t"
                        "pand      %%mm4, %%mm1\n\t"
                        "movq      %%mm1, %%mm0\n\t"
                        "psrld     $1, %%mm0\n\t"                   // t
                        "psllw     $0x0A, %%mm0\n\t"                // G
                        "psrlw     $0x02, %%mm1\n\t"
                        "psrld     $0x0d, %%mm1\n\t"                // t
                        "por       %%mm0, %%mm1\n\t"                // B
                        "psrld     $0x0A, %%mm2\n\t"                // t
                        "pslld     $0x13, %%mm2\n\t"                // R
                        "por       %%mm1, %%mm2\n\t"
                        "decl      %%ecx\n\t"
                        "jne       2b\n\t"
                        "movq      %%mm2, (%%ebx)\n\t"
                        "addl      $8, %%ebx\n\t"
                        "movq      %%mm5, (%%ebx)\n\t"

        "4:\n\t" //end
                        "emms\n\t"
                        :        /* no output */
                        :        /* input */
                        "m" (i1),       /* %0 */
                        "m" (i2),       /* %1 */
                        "m" (offset32), /* %2 */
                        "m" (y),        /* %3 */
                        "m" (perm_y),   /* %4 */
                        "m" (xsize),    /* %5 */
                        "m" (p2),       /* %6 */
                        "m" (p1),        /* %7 */
			"m" (*nMaskY),   /* %8 */
			"m" (*nPlus128)  /* %9 */
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
			,"m" (*nFaktoren) /* %10 */
#endif
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );
#else
  static char buf[768*2];
  palyuv0(i1, i2, offset32, y, perm_y, xsize, buf, p1);
  yuvtorgb32(p2, buf, xsize);
#endif
}


    //********************************************************************
    //                        P U T L I N E D U P   P A L   R G B 1 6
    //********************************************************************
inline void
putlinedup_PAL_RGB16 (int i1, int i2, int offset32, int y, int perm_y, int xsize,
            void *p2, void *p1, void *p2dup)
{
#ifdef ARCH_X86
  __asm__ __volatile__ (
                        // if (MSB(perm_y) == 1) i.e. if (perm_y > 32767 or 16383??) goto 1
                        "movl      %4, %%eax\n\t"                   // perm_y
                        "testl     %%eax, %%eax\n\t"
                        "js        1f\n\t"

                        // if (perm_y >= 32) goto 0
                        "cmpl      $0x00000020, %%eax\n\t"
                        "jae       0f\n\t"

                        // else perm_y = perm_y - offset32;
                        "subl      %2, %%eax\n\t"                   // offset32

        "0:\n\t"

                        // edi = 4 * (perm_y - y) + 1248
                        "subl      %3, %%eax\n\t"                   // y
                        "leal      0x4E0(, %%eax,4), %%edi\n\t"

                        // i1 = i1 & 0x01
                        // i2 = i2 & 0x01
                        "movl      %0, %%eax\n\t"                   // i1
                        "movl      %1, %%ebx\n\t"                   // i2
                        "andl      $00000001, %%eax\n\t"
                        "andl      $00000001, %%ebx\n\t"

                        // edi = edi + (i2 + 2 * i1)
                        "leal      (%%ebx, %%eax,2), %%eax\n\t"
                        "addl      %%eax, %%edi\n\t"

                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal      colortable(, %%edi,8), %%edi\n\t"

        "1:\n\t"
                        "movl      %7, %%edx\n\t"                   // p1
                        "movl      %5, %%ecx\n\t"                   // xsize

                        "movq      (%%edi), %%mm7\n\t"
                        "movq      %9, %%mm4\n\t"

                        "shrl      $3, %%ecx\n\t"                   // xsize /= 8
                        "movl      %6, %%ebx\n\t"                   // p2
                        "movl      %8, %%eax\n\t"                   // p2dup

                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1

                        "addl      $8, %%edx\n\t"                   // p1 += 8

                        "subl      $8, %%ebx\n\t"                   // p2 -= 8

                        "subl      $8, %%eax\n\t"                   // p2dup -= 8

                        "jmp       3f\n\t" //StartPixel

                        ".align 16\n\t"

        "2:\n\t" //NextPixel
                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1
                        "addl      $8, %%edx\n\t"                   // p1 += 8
                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 == mm2
                        "movq      %%mm2, (%%eax)\n\t"              // *p2dup = mm2

        "3:\n\t" //StartPixel
                        "movq      %%mm0, %%mm2\n\t"
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
			"psubb     %10, %%mm0\n\t"
#else
                        "psubb     nPlus128, %%mm0\n\t"             // U-128 V-128
#endif
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "addl      $8, %%eax\n\t"                   // p2dup += 8
                        "psraw     $8, %%mm0\n\t"
                        "pand      %%mm4, %%mm2\n\t"                // unmask UV
                        "movq      %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw     $1, %%mm2\n\t"
                        "pmaddwd   %%mm7, %%mm0\n\t"
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq      %%mm2, %%mm5\n\t"
                        "pmaddwd   %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad     $0x0B, %%mm0\n\t"
                        "psrad     $0x0B, %%mm1\n\t"
                        "packssdw  %%mm1, %%mm0\n\t"
                        "packssdw  %%mm1, %%mm1\n\t"
                        "paddsw    %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t"
                        "movq      %%mm0, %%mm6\n\t"
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
                        "movq      %11, %%mm3\n\t"
#else
                        "movq      nFaktoren, %%mm3\n\t"
#endif
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw    %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw    %%mm3, %%mm0\n\t"
                        "movq      %%mm2, %%mm1\n\t"
                        "psllq     $8, %%mm2\n\t"
                        "movq      %%mm6, %%mm3\n\t"
                        "psrlq     $0x30, %%mm6\n\t"
                        "por       %%mm1, %%mm2\n\t"
                        "paddsw    %%mm3, %%mm6\n\t"
                        "movq      %%mm5, %%mm3\n\t"
                        "psllq     $8, %%mm5\n\t"
                        "packsswb  %%mm6, %%mm6\n\t"
                        "movq      %%mm0, %%mm1\n\t"
                        "psrlq     $0x30, %%mm0\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "paddsw    %%mm1, %%mm0\n\t"
                        "pxor      %%mm1, %%mm1\n\t"
                        "packsswb  %%mm0, %%mm0\n\t"
                        "pxor      %%mm3, %%mm3\n\t"
                        "paddsb    %%mm0, %%mm5\n\t"
                        "paddsb    %%mm6, %%mm2\n\t"
                        "pcmpgtb   %%mm5, %%mm3\n\t"
                        "pandn     %%mm5, %%mm3\n\t"
                        "pcmpgtb   %%mm2, %%mm1\n\t"
                        "movq      %%mm3, %%mm0\n\t"
                        "pand      %%mm4, %%mm3\n\t"
                        "psrld     $0x0A, %%mm0\n\t"
                        "pandn     %%mm2, %%mm1\n\t"
                        "pslld     $0x1B, %%mm0\n\t"                // 0x1A
                        "movq      %%mm3, %%mm5\n\t"
                        "psrlw     $2, %%mm3\n\t"
                        "movq      %%mm1, %%mm2\n\t"
                        "psrld     $1, %%mm5\n\t"                   // 02
                        "pand      %%mm4, %%mm1\n\t"
                        "pslld     $0x15, %%mm5\n\t"
                        "por       %%mm0, %%mm5\n\t"
                        "movq      %%mm1, %%mm0\n\t"
                        "psrlw     $2, %%mm1\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "psrld     $1, %%mm0\n\t"                   // 02
                        "pslld     $0x15, %%mm0\n\t"
                        "psrad     $0x10, %%mm5\n\t"
                        "por       %%mm0, %%mm1\n\t"
                        "psrld     $0x0A, %%mm2\n\t"
                        "pslld     $0x1B, %%mm2\n\t"                // 0x1A
                        "por       %%mm1, %%mm2\n\t"
                        "psrad     $0x10, %%mm2\n\t"
                        "decl      %%ecx\n\t"
                        "packssdw  %%mm5, %%mm2\n\t"
                        "jne       2b\n\t" //NextPixel
                        "movq      %%mm2, (%%ebx)\n\t"
                        "movq      %%mm2, (%%eax)\n\t"

        "4:\n\t" //end
                        "emms\n\t"
                        :        /* no output */
                        :        /* input */
                        "m" (i1),       /* %0 */
                        "m" (i2),       /* %1 */
                        "m" (offset32), /* %2 */
                        "m" (y),        /* %3 */
                        "m" (perm_y),   /* %4 */
                        "m" (xsize),    /* %5 */
                        "m" (p2),       /* %6 */
                        "m" (p1),       /* %7 */
                        "m" (p2dup),     /* %8 */
			"m" (*nMaskY)     /* %9 */
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
			,"m" (*nPlus128),  /* %10 */
			"m" (*nFaktoren)   /* %11 */
#endif
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );
#else
  putline_PAL_RGB16(i1, i2, offset32, y, perm_y, xsize, p2, p1);
  fast_memcpy(p2dup, p2, xsize);
#endif
}

inline void
putlinedup_PAL_RGB15 (int i1, int i2, int offset32, int y, int perm_y, int xsize,
            void *p2, void *p1, void *p2dup)
{
  putline_PAL_RGB15(i1, i2, offset32, y, perm_y, xsize, p2, p1);
  fast_memcpy(p2dup, p2, xsize);
}

    //********************************************************************
    //                        P U T L I N E D U P   P A L   R G B 3 2
    //********************************************************************
inline void
putlinedup_PAL_RGB32 (int i1, int i2, int offset32, int y, int perm_y, int xsize,
            void *p2, void *p1, void *p2dup)
{
#ifdef ARCH_X86
  __asm__ __volatile__ (
                        // if (MSB(perm_y) == 1) i.e. if (perm_y > 32767 or 16383??) goto 1
                        "movl      %4, %%eax\n\t"                   // perm_y
                        "testl     %%eax, %%eax\n\t"
                        "js        1f\n\t"

                        // if (perm_y >= 32) goto 0
                        "cmpl      $0x00000020, %%eax\n\t"
                        "jae       0f\n\t"

                        // else perm_y = perm_y - offset32;
                        "subl      %2, %%eax\n\t"                   // offset32

        "0:\n\t"

                        // else perm_y = perm_y - offset32;
                        "subl      %3, %%eax\n\t"                   // y
                        "leal      0x4E0(, %%eax,4), %%edi\n\t"

                        // i1 = i1 & 0x01
                        // i2 = i2 & 0x01
                        "movl      %0, %%eax\n\t"                   // i1
                        "movl      %1, %%ebx\n\t"                   // i2
                        "andl      $00000001, %%eax\n\t"
                        "andl      $00000001, %%ebx\n\t"

                        // edi = edi + (i2 + 2 * i1)
                        "leal      (%%ebx, %%eax,2), %%eax\n\t"
                        "addl      %%eax, %%edi\n\t"

                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal      colortable(, %%edi,8), %%edi\n\t"

        "1:\n\t"
                        "movl      %7, %%edx\n\t"                   // p1
                        "movl      %5, %%ecx\n\t"                   // xsize

                        "movq      (%%edi), %%mm7\n\t"
                        "movq      %9, %%mm4\n\t"

                        "shrl      $3, %%ecx\n\t"                   // xsize /= 8
                        "movl      %6, %%ebx\n\t"                   // p2
                        "movl      %8, %%eax\n\t"                   // p2dup

                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1

                        "addl      $8, %%edx\n\t"                   // p1 += 8

                        "subl      $8, %%ebx\n\t"                   // p2 -= 8

                        "subl      $8, %%eax\n\t"                   // p2dup -= 8

                        "jmp       3f\n\t" //StartPixel

                        ".align 16\n\t"

        "2:\n\t" //NextPixel
                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1
                        "addl      $8, %%edx\n\t"                   // p1 += 8
                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 == mm2
                        "movq      %%mm2, (%%eax)\n\t"              // *p2dup = mm2
                        "addl      $8, %%ebx\n\t"
                        "addl      $8, %%eax\n\t"
                        "movq      %%mm5, (%%ebx)\n\t"
                        "movq      %%mm5, (%%eax)\n\t"

        "3:\n\t" //StartPixel
                        "movq      %%mm0, %%mm2\n\t"
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
			"psubb     %10, %%mm0\n\t"
#else
                        "psubb     nPlus128, %%mm0\n\t"             // U-128 V-128
#endif
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "addl      $8, %%eax\n\t"                   // p2dup += 8
                        "psraw     $8, %%mm0\n\t"
                        "pand      %%mm4, %%mm2\n\t"                // unmask UV
                        "movq      %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw     $1, %%mm2\n\t"
                        "pmaddwd   %%mm7, %%mm0\n\t"                // mm0 += *pColorFaktor
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq      %%mm2, %%mm5\n\t"
                        "pmaddwd   %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad     $0x0B, %%mm0\n\t"
                        "psrad     $0x0B, %%mm1\n\t"
                        "packssdw  %%mm1, %%mm0\n\t"
                        "packssdw  %%mm1, %%mm1\n\t"
                        "paddsw    %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t"
                        "movq      %%mm0, %%mm6\n\t"
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
                        "movq      %11, %%mm3\n\t"
#else
                        "movq      nFaktoren, %%mm3\n\t"
#endif
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw    %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw    %%mm3, %%mm0\n\t"
                        "movq      %%mm2, %%mm1\n\t"
                        "psllq     $8, %%mm2\n\t"
                        "por       %%mm1, %%mm2\n\t"
                        "movq      %%mm6, %%mm3\n\t"
                        "psrlq     $0x30, %%mm6\n\t"
                        "paddsw    %%mm3, %%mm6\n\t"
                        "packsswb  %%mm6, %%mm6\n\t"
                        "movq      %%mm5, %%mm3\n\t"
                        "psllq     $8, %%mm5\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "movq      %%mm0, %%mm1\n\t"
                        "psrlq     $0x30, %%mm0\n\t"
                        "paddsw    %%mm1, %%mm0\n\t"
                        "packsswb  %%mm0, %%mm0\n\t"
                        "paddsb    %%mm0, %%mm5\n\t"
                        "paddsb    %%mm6, %%mm2\n\t"
                        "pxor      %%mm1, %%mm1\n\t"
                        "pxor      %%mm3, %%mm3\n\t"
                        "pcmpgtb   %%mm5, %%mm3\n\t"
                        "pandn     %%mm5, %%mm3\n\t"
                        "pcmpgtb   %%mm2, %%mm1\n\t"
                        "pandn     %%mm2, %%mm1\n\t"
                        "movq      %%mm3, %%mm0\n\t"
                        "psrld     $0x0A, %%mm0\n\t"                // t
                        "pslld     $0x13, %%mm0\n\t"                // R
                        "pand      %%mm4, %%mm3\n\t"
                        "movq      %%mm3, %%mm5\n\t"
                        "psrld     $1, %%mm5\n\t"                   // t
                        "psllw     $0x0A, %%mm5\n\t"                // G
                        "por       %%mm0, %%mm5\n\t"
                        "psrlw     $0x02, %%mm3\n\t"
                        "psrld     $0x0d, %%mm3\n\t"                // t
                        "por       %%mm3, %%mm5\n\t"                // B
                        "movq      %%mm1, %%mm2\n\t"
                        "pand      %%mm4, %%mm1\n\t"
                        "movq      %%mm1, %%mm0\n\t"
                        "psrld     $1, %%mm0\n\t"                   // t
                        "psllw     $0x0A, %%mm0\n\t"                // G
                        "psrlw     $0x02, %%mm1\n\t"
                        "psrld     $0x0d, %%mm1\n\t"                // t
                        "por       %%mm0, %%mm1\n\t"                // B
                        "psrld     $0x0A, %%mm2\n\t"                // t
                        "pslld     $0x13, %%mm2\n\t"                // R
                        "por       %%mm1, %%mm2\n\t"
                        "decl      %%ecx\n\t"
                        "jne       2b\n\t" //NextPixel
                        "movq      %%mm2, (%%ebx)\n\t"
                        "movq      %%mm2, (%%eax)\n\t"
                        "addl      $8, %%ebx\n\t"
                        "addl      $8, %%eax\n\t"
                        "movq      %%mm5, (%%ebx)\n\t"
                        "movq      %%mm5, (%%eax)\n\t"

        "4:\n\t" //end
                        "emms\n\t"
                        :        /* no output */
                        :        /* input */
                        "m" (i1),       /* %0 */
                        "m" (i2),       /* %1 */
                        "m" (offset32), /* %2 */
                        "m" (y),        /* %3 */
                        "m" (perm_y),   /* %4 */
                        "m" (xsize),    /* %5 */
                        "m" (p2),       /* %6 */
                        "m" (p1),       /* %7 */
                        "m" (p2dup),    /* %8 */
			"m" (*nMaskY)     /* %9 */
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
			,"m" (*nPlus128),   /* %10 */
			"m" (*nFaktoren)   /* %11 */
#endif
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );
#else
  putline_PAL_RGB32(i1, i2, offset32, y, perm_y, xsize, p2, p1);
  fast_memcpy(p2dup, p2, 2*xsize);
#endif
}



    //********************************************************************
    //                        P U T L I N E    S E C A M   R G B 1 6
    //********************************************************************
inline void
putline_SECAM_RGB16 (int xsize, void *p2, void *p1)
{
#ifdef ARCH_X86
  __asm__ __volatile__ (
                        //"movl colortable_offset, %%edi\n\t"
                        // edi = 4*32+1248
                        //"movl      $32, %%eax\n\t"
                        //"leal      0x4E0(, %%eax,4), %%edi\n\t"
                        "movl $1376, %%edi\n\t"
                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal      colortable(, %%edi,8), %%edi\n\t"

        "1:\n\t"

                        "movl      %2, %%edx\n\t"                   // p1
                        "movl      %0, %%ecx\n\t"                   // xsize

                        "movq      (%%edi), %%mm7\n\t"              // mm7 = *pColorFaktor (64 bits)
                        "movq      %3, %%mm4\n\t"

                        "shrl      $3, %%ecx\n\t"                   // xsize /= 8
                        "movl      %1, %%ebx\n\t"                   // p2

                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1

                        "addl      $8, %%edx\n\t"                   // p1 += 8

                        "subl      $8, %%ebx\n\t"                   // p2 -= 8 

                        "jmp       3f\n\t" //StartPixel

                        ".align 16\n\t"

        "2:\n\t" //NextPixel
                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1
                        "addl      $8, %%edx\n\t"                   // p1 += 8
                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 = mm2


        "3:\n\t" //StartPixel
                        "movq      %%mm0, %%mm2\n\t"
                        "psubb     %4, %%mm0\n\t"             // U-128 V-128
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "psraw     $8, %%mm0\n\t"
                        "pand      %%mm4, %%mm2\n\t"                // unmask UV
                        "movq      %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw     $1, %%mm2\n\t"
                        "pmaddwd   %%mm7, %%mm0\n\t"                // mm0 += *pColorFaktor
                        // ??? movq mm6
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq      %%mm2, %%mm5\n\t"
                        "pmaddwd   %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad     $0x0B, %%mm0\n\t"
                        "psrad     $0x0B, %%mm1\n\t"
                        "packssdw  %%mm1, %%mm0\n\t"
                        // ??? movd eax
                        "packssdw  %%mm1, %%mm1\n\t"
                        "paddsw    %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t"
                        "movq      %%mm0, %%mm6\n\t"
                        "movq      %5,    %%mm3\n\t"
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw    %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw    %%mm3, %%mm0\n\t"
                        "movq      %%mm2, %%mm1\n\t"
                        "psllq     $8, %%mm2\n\t"
                        "movq      %%mm6, %%mm3\n\t"
                        "psrlq     $0x30, %%mm6\n\t"
                        "por       %%mm1, %%mm2\n\t"
                        "paddsw    %%mm3, %%mm6\n\t"
                        "movq      %%mm5, %%mm3\n\t"
                        "psllq     $8, %%mm5\n\t"
                        "packsswb  %%mm6, %%mm6\n\t"
                        "movq      %%mm0, %%mm1\n\t"
                        "psrlq     $0x30, %%mm0\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "paddsw    %%mm1, %%mm0\n\t"
                        "pxor      %%mm1, %%mm1\n\t"
                        "packsswb  %%mm0, %%mm0\n\t"
                        "pxor      %%mm3, %%mm3\n\t"
                        "paddsb    %%mm0, %%mm5\n\t"
                        "paddsb    %%mm6, %%mm2\n\t"
                        "pcmpgtb   %%mm5, %%mm3\n\t"
                        "pandn     %%mm5, %%mm3\n\t"
                        "pcmpgtb   %%mm2, %%mm1\n\t"
                        "movq      %%mm3, %%mm0\n\t"
                        "pand      %%mm4, %%mm3\n\t"
                        "psrld     $0x0A, %%mm0\n\t"
                        "pandn     %%mm2, %%mm1\n\t"
                        "pslld     $0x1B, %%mm0\n\t"                // 0x1A
                        "movq      %%mm3, %%mm5\n\t"
                        "psrlw     $2, %%mm3\n\t"
                        "movq      %%mm1, %%mm2\n\t"
                        "psrld     $1, %%mm5\n\t"                   // 02
                        "pand      %%mm4, %%mm1\n\t"
                        "pslld     $0x15, %%mm5\n\t"
                        "por       %%mm0, %%mm5\n\t"
                        "movq      %%mm1, %%mm0\n\t"
                        "psrlw     $2, %%mm1\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "psrld     $1, %%mm0\n\t"                   // 02
                        "pslld     $0x15, %%mm0\n\t"
                        "psrad     $0x10, %%mm5\n\t"
                        "por       %%mm0, %%mm1\n\t"
                        "psrld     $0x0A, %%mm2\n\t"
                        "pslld     $0x1B, %%mm2\n\t"                // 0x1A
                        "por       %%mm1, %%mm2\n\t"
                        "psrad     $0x10, %%mm2\n\t"
                        "decl      %%ecx\n\t"
                        "packssdw  %%mm5, %%mm2\n\t"
                        "jne       2b\n\t" //NextPixel

                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 = mm2

        "4:\n\t" //end
                        "emms\n\t"
                        :        /* no output */
                        :        /* input */
                        "m" (xsize),    /* %0 */
                        "m" (p2),       /* %1 */
                        "m" (p1),       /* %2 */
			"m" (*nMaskY),   /* %3 */
			"m" (*nPlus128),  /* %4 */
			"m" (*nFaktoren)  /* %5 */
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );
#else
  yuvtorgb16(p2,p1,xsize);
#endif
}

inline void
putline_SECAM_RGB15 (int xsize, void *p2, void *p1)
{
  putline_SECAM_RGB16(xsize, p2, p1);
  plug_rgb16to15(p2, xsize/2);
}

    //********************************************************************
    //                        P U T L I N E   S E C A M   R G B 3 2
    //********************************************************************

inline void
putline_SECAM_RGB32 (int xsize, void *p2, void *p1)
{
#ifdef ARCH_X86
  __asm__ __volatile__ (
                        //"movl colortable_offset, %%edi\n\t"
                        // edi = 4*32+1248
                        //"movl      $32, %%eax\n\t"
                        //"leal      0x4E0(, %%eax,4), %%edi\n\t"
                        "movl $1376, %%edi\n\t"
                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal      colortable(, %%edi,8), %%edi\n\t"

        "1:\n\t"

                        "movl      %2, %%edx\n\t"                   // p1
                        "movl      %0, %%ecx\n\t"                   // xsize

                        "movq      (%%edi), %%mm7\n\t"              // mm7 = *pColorFaktor (64 bits)
                        "movq      %3, %%mm4\n\t"

                        "shrl      $3, %%ecx\n\t"                   // xsize /= 8
                        "movl      %1, %%ebx\n\t"                   // p2

                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1

                        "addl      $8, %%edx\n\t"                   // p1 += 8

                        "subl      $8, %%ebx\n\t"                   // p2 -= 8

                        "jmp       3f\n\t" //StartPixel

                        ".align 16\n\t"

        "2:\n\t" //NextPixel
                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1
                        "addl      $8, %%edx\n\t"                   // p1 += 8
                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 = mm2
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "movq      %%mm5, (%%ebx)\n\t"              // *p2 = mm5

        "3:\n\t" //StartPixel
                        "movq      %%mm0, %%mm2\n\t"
                        "psubb     %4, %%mm0\n\t"             // U-128 V-128
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "psraw     $8, %%mm0\n\t"
                        "pand      %%mm4, %%mm2\n\t"                // unmask UV
                        "movq      %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw     $1, %%mm2\n\t"
                        "pmaddwd   %%mm7, %%mm0\n\t"                // mm0 += *pColorFaktor
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq      %%mm2, %%mm5\n\t"
                        "pmaddwd   %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad     $0x0B, %%mm0\n\t"
                        "psrad     $0x0B, %%mm1\n\t"
                        "packssdw  %%mm1, %%mm0\n\t"
                        "packssdw  %%mm1, %%mm1\n\t"
                        "paddsw    %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t"
                        "movq      %%mm0, %%mm6\n\t"
                        "movq      %5, %%mm3\n\t"
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw    %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw    %%mm3, %%mm0\n\t"
                        "movq      %%mm2, %%mm1\n\t"
                        "psllq     $8, %%mm2\n\t"
                        "por       %%mm1, %%mm2\n\t"
                        "movq      %%mm6, %%mm3\n\t"
                        "psrlq     $0x30, %%mm6\n\t"
                        "paddsw    %%mm3, %%mm6\n\t"
                        "packsswb  %%mm6, %%mm6\n\t"
                        "movq      %%mm5, %%mm3\n\t"
                        "psllq     $8, %%mm5\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "movq      %%mm0, %%mm1\n\t"
                        "psrlq     $0x30, %%mm0\n\t"
                        "paddsw    %%mm1, %%mm0\n\t"
                        "packsswb  %%mm0, %%mm0\n\t"
                        "paddsb    %%mm0, %%mm5\n\t"
                        "paddsb    %%mm6, %%mm2\n\t"
                        "pxor      %%mm1, %%mm1\n\t"
                        "pxor      %%mm3, %%mm3\n\t"
                        "pcmpgtb   %%mm5, %%mm3\n\t"
                        "pandn     %%mm5, %%mm3\n\t"
                        "pcmpgtb   %%mm2, %%mm1\n\t"
                        "pandn     %%mm2, %%mm1\n\t"
                        "movq      %%mm3, %%mm0\n\t"
                        "psrld     $0x0A, %%mm0\n\t"                // t
                        "pslld     $0x13, %%mm0\n\t"                // R
                        "pand      %%mm4, %%mm3\n\t"
                        "movq      %%mm3, %%mm5\n\t"
                        "psrld     $1, %%mm5\n\t"                   // t
                        "psllw     $0x0A, %%mm5\n\t"                // G
                        "por       %%mm0, %%mm5\n\t"
                        "psrlw     $0x02, %%mm3\n\t"
                        "psrld     $0x0d, %%mm3\n\t"                // t
                        "por       %%mm3, %%mm5\n\t"                // B
                        "movq      %%mm1, %%mm2\n\t"
                        "pand      %%mm4, %%mm1\n\t"
                        "movq      %%mm1, %%mm0\n\t"
                        "psrld     $1, %%mm0\n\t"                   // t
                        "psllw     $0x0A, %%mm0\n\t"                // G
                        "psrlw     $0x02, %%mm1\n\t"
                        "psrld     $0x0d, %%mm1\n\t"                // t
                        "por       %%mm0, %%mm1\n\t"                // B
                        "psrld     $0x0A, %%mm2\n\t"                // t
                        "pslld     $0x13, %%mm2\n\t"                // R
                        "por       %%mm1, %%mm2\n\t"
                        "decl      %%ecx\n\t"
                        "jne       2b\n\t" //NextPixel
                        "movq      %%mm2, (%%ebx)\n\t"
                        "addl      $8, %%ebx\n\t"
                        "movq      %%mm5, (%%ebx)\n\t"

        "4:\n\t" //end
                        "emms\n\t"
                        :        /* no output */
                        :        /* input */
                        "m" (xsize),    /* %0 */
                        "m" (p2),       /* %1 */
                        "m" (p1),        /* %2 */
			"m" (*nMaskY),   /* %3 */
			"m" (*nPlus128),  /* %4 */
			"m" (*nFaktoren)  /* %5 */
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );
#else
  yuvtorgb32(p2,p1,xsize);
#endif
}


    //********************************************************************
    //                        P U T L I N E D U P   S E C A M   R G B 1 6
    //********************************************************************
inline void
putlinedup_SECAM_RGB16 (int xsize, void *p2, void *p1, void *p2dup)
{
#ifdef ARCH_X86
  __asm__ __volatile__ (
                        //"movl colortable_offset, %%edi\n\t"
                        // edi = 4*32+1248
                        //"movl      $32, %%eax\n\t"
                        //"leal      0x4E0(, %%eax,4), %%edi\n\t"
                        "movl $1376, %%edi\n\t"
                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal      colortable(, %%edi,8), %%edi\n\t"

        "1:\n\t"
                        "movl      %2, %%edx\n\t"                   // p1
                        "movl      %0, %%ecx\n\t"                   // xsize

                        "movq      (%%edi), %%mm7\n\t"
                        "movq      %4, %%mm4\n\t"

                        "shrl      $3, %%ecx\n\t"                   // xsize /= 8
                        "movl      %1, %%ebx\n\t"                   // p2
                        "movl      %3, %%eax\n\t"                   // p2dup

                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1

                        "addl      $8, %%edx\n\t"                   // p1 += 8

                        "subl      $8, %%ebx\n\t"                   // p2 -= 8

                        "subl      $8, %%eax\n\t"                   // p2dup -= 8

                        "jmp       3f\n\t" //StartPixel

                        ".align 16\n\t"

        "2:\n\t" //NextPixel
                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1
                        "addl      $8, %%edx\n\t"                   // p1 += 8
                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 == mm2
                        "movq      %%mm2, (%%eax)\n\t"              // *p2dup = mm2

        "3:\n\t" //StartPixel
                        "movq      %%mm0, %%mm2\n\t"
                        "psubb     %5, %%mm0\n\t"             // U-128 V-128
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "addl      $8, %%eax\n\t"                   // p2dup += 8
                        "psraw     $8, %%mm0\n\t"
                        "pand      %%mm4, %%mm2\n\t"                // unmask UV
                        "movq      %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw     $1, %%mm2\n\t"
                        "pmaddwd   %%mm7, %%mm0\n\t"
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq      %%mm2, %%mm5\n\t"
                        "pmaddwd   %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad     $0x0B, %%mm0\n\t"
                        "psrad     $0x0B, %%mm1\n\t"
                        "packssdw  %%mm1, %%mm0\n\t"
                        "packssdw  %%mm1, %%mm1\n\t"
                        "paddsw    %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t"
                        "movq      %%mm0, %%mm6\n\t"
                        "movq      %6, %%mm3\n\t"
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw    %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw    %%mm3, %%mm0\n\t"
                        "movq      %%mm2, %%mm1\n\t"
                        "psllq     $8, %%mm2\n\t"
                        "movq      %%mm6, %%mm3\n\t"
                        "psrlq     $0x30, %%mm6\n\t"
                        "por       %%mm1, %%mm2\n\t"
                        "paddsw    %%mm3, %%mm6\n\t"
                        "movq      %%mm5, %%mm3\n\t"
                        "psllq     $8, %%mm5\n\t"
                        "packsswb  %%mm6, %%mm6\n\t"
                        "movq      %%mm0, %%mm1\n\t"
                        "psrlq     $0x30, %%mm0\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "paddsw    %%mm1, %%mm0\n\t"
                        "pxor      %%mm1, %%mm1\n\t"
                        "packsswb  %%mm0, %%mm0\n\t"
                        "pxor      %%mm3, %%mm3\n\t"
                        "paddsb    %%mm0, %%mm5\n\t"
                        "paddsb    %%mm6, %%mm2\n\t"
                        "pcmpgtb   %%mm5, %%mm3\n\t"
                        "pandn     %%mm5, %%mm3\n\t"
                        "pcmpgtb   %%mm2, %%mm1\n\t"
                        "movq      %%mm3, %%mm0\n\t"
                        "pand      %%mm4, %%mm3\n\t"
                        "psrld     $0x0A, %%mm0\n\t"
                        "pandn     %%mm2, %%mm1\n\t"
                        "pslld     $0x1B, %%mm0\n\t"                // 0x1A
                        "movq      %%mm3, %%mm5\n\t"
                        "psrlw     $2, %%mm3\n\t"
                        "movq      %%mm1, %%mm2\n\t"
                        "psrld     $1, %%mm5\n\t"                   // 02
                        "pand      %%mm4, %%mm1\n\t"
                        "pslld     $0x15, %%mm5\n\t"
                        "por       %%mm0, %%mm5\n\t"
                        "movq      %%mm1, %%mm0\n\t"
                        "psrlw     $2, %%mm1\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "psrld     $1, %%mm0\n\t"                   // 02
                        "pslld     $0x15, %%mm0\n\t"
                        "psrad     $0x10, %%mm5\n\t"
                        "por       %%mm0, %%mm1\n\t"
                        "psrld     $0x0A, %%mm2\n\t"
                        "pslld     $0x1B, %%mm2\n\t"                // 0x1A
                        "por       %%mm1, %%mm2\n\t"
                        "psrad     $0x10, %%mm2\n\t"
                        "decl      %%ecx\n\t"
                        "packssdw  %%mm5, %%mm2\n\t"
                        "jne       2b\n\t" //NextPixel
                        "movq      %%mm2, (%%ebx)\n\t"
                        "movq      %%mm2, (%%eax)\n\t"

        "4:\n\t" //end
                        "emms\n\t"
                        :        /* no output */
                        :        /* input */
                        "m" (xsize),    /* %0 */
                        "m" (p2),       /* %1 */
                        "m" (p1),       /* %2 */
                        "m" (p2dup),    /* %3 */
			"m" (*nMaskY),   /* %4 */
			"m" (*nPlus128),  /* %5 */
			"m" (*nFaktoren)  /* %6 */
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );
#else
  putline_SECAM_RGB16(xsize, p2, p1);
  fast_memcpy(p2dup, p2, xsize);
#endif
}

inline void
putlinedup_SECAM_RGB15 (int xsize, void *p2, void *p1, void *p2dup)
{
  putline_SECAM_RGB15(xsize, p2, p1);
  fast_memcpy(p2dup, p2, xsize);
}

    //********************************************************************
    //                        P U T L I N E D U P   S E C A M   R G B 3 2
    //********************************************************************
inline void
putlinedup_SECAM_RGB32 (int xsize, void *p2, void *p1, void *p2dup)
{
#ifdef ARCH_X86
  __asm__ __volatile__ (
                        //"movl colortable_offset, %%edi\n\t"
                        // edi = 4*32+1248
                        //"movl      $32, %%eax\n\t"
                        //"leal      0x4E0(, %%eax,4), %%edi\n\t"
                        "movl $1376, %%edi\n\t"
                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal      colortable(, %%edi,8), %%edi\n\t"

        "1:\n\t"
                        "movl      %2, %%edx\n\t"                   // p1
                        "movl      %0, %%ecx\n\t"                   // xsize

                        "movq      (%%edi), %%mm7\n\t"
                        "movq      %4, %%mm4\n\t"

                        "shrl      $3, %%ecx\n\t"                   // xsize /= 8
                        "movl      %1, %%ebx\n\t"                   // p2
                        "movl      %3, %%eax\n\t"                   // p2dup

                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1

                        "addl      $8, %%edx\n\t"                   // p1 += 8

                        "subl      $8, %%ebx\n\t"                   // p2 -= 8

                        "subl      $8, %%eax\n\t"                   // p2dup -= 8

                        "jmp       3f\n\t" //StartPixel

                        ".align 16\n\t"

        "2:\n\t" //NextPixel
                        "movq      (%%edx), %%mm0\n\t"              // mm0 = *p1
                        "addl      $8, %%edx\n\t"                   // p1 += 8
                        "movq      %%mm2, (%%ebx)\n\t"              // *p2 == mm2
                        "movq      %%mm2, (%%eax)\n\t"              // *p2dup = mm2
                        "addl      $8, %%ebx\n\t"
                        "addl      $8, %%eax\n\t"
                        "movq      %%mm5, (%%ebx)\n\t"
                        "movq      %%mm5, (%%eax)\n\t"

        "3:\n\t" //StartPixel
                        "movq      %%mm0, %%mm2\n\t"
                        "psubb     %5, %%mm0\n\t"             // U-128 V-128
                        "addl      $8, %%ebx\n\t"                   // p2 += 8
                        "addl      $8, %%eax\n\t"                   // p2dup += 8
                        "psraw     $8, %%mm0\n\t"
                        "pand      %%mm4, %%mm2\n\t"                // unmask UV
                        "movq      %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw     $1, %%mm2\n\t"
                        "pmaddwd   %%mm7, %%mm0\n\t"                // mm0 += *pColorFaktor
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq      %%mm2, %%mm5\n\t"
                        "pmaddwd   %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad     $0x0B, %%mm0\n\t"
                        "psrad     $0x0B, %%mm1\n\t"
                        "packssdw  %%mm1, %%mm0\n\t"
                        "packssdw  %%mm1, %%mm1\n\t"
                        "paddsw    %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t"
                        "movq      %%mm0, %%mm6\n\t"
                        "movq      %6, %%mm3\n\t"
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw    %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw    %%mm3, %%mm0\n\t"
                        "movq      %%mm2, %%mm1\n\t"
                        "psllq     $8, %%mm2\n\t"
                        "por       %%mm1, %%mm2\n\t"
                        "movq      %%mm6, %%mm3\n\t"
                        "psrlq     $0x30, %%mm6\n\t"
                        "paddsw    %%mm3, %%mm6\n\t"
                        "packsswb  %%mm6, %%mm6\n\t"
                        "movq      %%mm5, %%mm3\n\t"
                        "psllq     $8, %%mm5\n\t"
                        "por       %%mm3, %%mm5\n\t"
                        "movq      %%mm0, %%mm1\n\t"
                        "psrlq     $0x30, %%mm0\n\t"
                        "paddsw    %%mm1, %%mm0\n\t"
                        "packsswb  %%mm0, %%mm0\n\t"
                        "paddsb    %%mm0, %%mm5\n\t"
                        "paddsb    %%mm6, %%mm2\n\t"
                        "pxor      %%mm1, %%mm1\n\t"
                        "pxor      %%mm3, %%mm3\n\t"
                        "pcmpgtb   %%mm5, %%mm3\n\t"
                        "pandn     %%mm5, %%mm3\n\t"
                        "pcmpgtb   %%mm2, %%mm1\n\t"
                        "pandn     %%mm2, %%mm1\n\t"
                        "movq      %%mm3, %%mm0\n\t"
                        "psrld     $0x0A, %%mm0\n\t"                // t
                        "pslld     $0x13, %%mm0\n\t"                // R
                        "pand      %%mm4, %%mm3\n\t"
                        "movq      %%mm3, %%mm5\n\t"
                        "psrld     $1, %%mm5\n\t"                   // t
                        "psllw     $0x0A, %%mm5\n\t"                // G
                        "por       %%mm0, %%mm5\n\t"
                        "psrlw     $0x02, %%mm3\n\t"
                        "psrld     $0x0d, %%mm3\n\t"                // t
                        "por       %%mm3, %%mm5\n\t"                // B
                        "movq      %%mm1, %%mm2\n\t"
                        "pand      %%mm4, %%mm1\n\t"
                        "movq      %%mm1, %%mm0\n\t"
                        "psrld     $1, %%mm0\n\t"                   // t
                        "psllw     $0x0A, %%mm0\n\t"                // G
                        "psrlw     $0x02, %%mm1\n\t"
                        "psrld     $0x0d, %%mm1\n\t"                // t
                        "por       %%mm0, %%mm1\n\t"                // B
                        "psrld     $0x0A, %%mm2\n\t"                // t
                        "pslld     $0x13, %%mm2\n\t"                // R
                        "por       %%mm1, %%mm2\n\t"
                        "decl      %%ecx\n\t"
                        "jne       2b\n\t" //NextPixel
                        "movq      %%mm2, (%%ebx)\n\t"
                        "movq      %%mm2, (%%eax)\n\t"
                        "addl      $8, %%ebx\n\t"
                        "addl      $8, %%eax\n\t"
                        "movq      %%mm5, (%%ebx)\n\t"
                        "movq      %%mm5, (%%eax)\n\t"

        "4:\n\t" //end
                        "emms\n\t"
                        :        /* no output */
                        :        /* input */
                        "m" (xsize),    /* %0 */
                        "m" (p2),       /* %1 */
                        "m" (p1),       /* %2 */
                        "m" (p2dup),    /* %3 */
			"m" (*nMaskY),  /* %4 */
			"m" (*nPlus128), /* %5 */
			"m" (*nFaktoren) /* %6 */
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );
#else
  putline_SECAM_RGB32(xsize, p2, p1);
  fast_memcpy(p2dup, p2, 2*xsize);
#endif
}



    //********************************************************************
    //                        P U T L I N E S W
    //********************************************************************

inline void
putlinesw (void *src, void *dest, int size)
{
#ifdef ARCH_X86
  __asm__ __volatile__ ("movl      %0, %%ebx\n\t"    // src
                        "movl      %1, %%esi\n\t"    // dest
                        "movl      %2, %%ecx\n\t"    // size 
                        "shrl      $2, %%ecx\n\t"
                        "movq      %3, %%mm6\n\t"

                        ".align 16\n\t"

        "0:\n\t" //constw
                        "movq      (%%ebx), %%mm1\n\t"
                        "pand      %%mm6, %%mm1\n\t"
                        "psrlw     $3, %%mm1\n\t"
                        "movq      %%mm1, %%mm2\n\t"
                        "psllw     $6, %%mm2\n\t"
                        "movq      %%mm1, %%mm3\n\t"
                        "psllw     $11, %%mm3\n\t"
                        "por       %%mm2, %%mm1\n\t"
                        "por       %%mm3, %%mm1\n\t"
                        "movq      %%mm1, (%%esi)\n\t"
                        "addl      $8, %%esi\n\t"
                        "addl      $8, %%ebx\n\t"
                        "decl      %%ecx\n\t"
                        "jnz       0b\n\t" //constw
                        "emms\n\t"
                        :        /* no output */
                        :        /* input */
                        "m" (src),    /* %0 */
                        "m" (dest),   /* %1 */
                        "m" (size),   /* %2 */
                        "m" (*ands)    /* %3 */
                        :        /* modified regs */
                        "ebx", "ecx", "esi"
                        /*, "mm1" */
    );
#else
  fprintf(stderr, "non-asm putlinesw non-implemented\n");
#endif
}
